//+------------------------------------------------------------------+
//|                       07.mq4 |
//|                      Copyright  2006,          . |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Procent_depo= 30;             //    
extern int  max_open_orders=1;              //  -    
extern bool close_all_swap=true;            //    ,  
extern int my_prosadka=5;                   //     
      extern int       MyHour_End=21;       //    - 
      extern int       MyMinute_End=55;     //    - 
      extern int       MyHour_Start=22;     //    - 
      extern int       MyMinute_Start=05;   //    - 

extern bool my_iMA=true;                    //    /
extern bool my_iMA2=false;                  //
extern bool my_iMA3=true;                   //
extern bool my_MACD=false;                  //
extern bool my_PIVOT=false;                 //  PivotLinesTimeZone.ex4
extern bool my_SupRes=false;                //  support resistance.ex4
extern bool my_iMA4=false;                  //
extern bool my_iMACD2=true;                 //
extern bool my_iRSI=true;                   //

extern int  zaderjka=5000;
extern bool trailing_parabol=true;          //   
extern bool zakr_ubitok=true;               //    
extern bool close_all_on_exit=false;        //    
extern int dop_prosadka_punkt=6;            //    . (slippage)
extern double TakeProfit         = 150;
extern double StopLoss           = 50;

extern int TSpar=50;
extern int ZeroBar=5;                      // ,       -   

int my_trailing;                           //     
double Points;
string error_string,primech;               //  
double Lot;                                //  
int err;
int Time_0;                                //    
extern int Plecho=1000;                    //      
    
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if (IsTesting()) zaderjka=0;
   Points = MarketInfo (Symbol(), MODE_POINT);
   double s;
   double my_spread;
   my_trailing=MarketInfo( Symbol(), MODE_STOPLEVEL ); //     
   s = MarketInfo(Symbol(), MODE_SPREAD); //   
   my_spread = s*Point;  // -        
   expiration_otlojen();
   Time_0 = 0; //  
   my_spread=MarketInfo(Symbol(), MODE_STOPLEVEL);
   double price_lot=(MarketInfo(Symbol(), MODE_LOTSIZE)/(AccountLeverage()*(iClose(Symbol(), Period(), iBarShift(Symbol(), Period(), CurTime(), true))))); //  1- 
   RefreshRates();
   err=GetLastError();
   Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol()," , ...  =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
if (close_all_on_exit==true)
{
   Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol()," , ...  =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit());
   Close_vstrechn();
   MyHour_End=TimeHour(CurTime());
   MyMinute_End=TimeMinute(CurTime());
   close_all_21();
}   
//----
   return(0);
  }
  

int SetOrderBuy()
{
Print(Symbol(),"  ");
      close_sell();
if (AllowedOpenOrder(OP_BUY)>0)
{
      int res0;
      res0=OrderSend(Symbol(),OP_BUY,Lots(),Ask,3,Ask-StopLoss*Points,Ask+TakeProfit*Points,"",0,0,Blue);
}
      return;
}

int SetOrderSell()
{
Print(Symbol(),"  SELL");
      close_buy();
if (AllowedOpenOrder(OP_SELL)>0)
{
      int res0;
      res0=OrderSend(Symbol(),OP_SELL,Lots(),Bid,3,Bid+StopLoss*Points,Bid-TakeProfit*Points,"",0,0,Red);
}
      return;
}  

int close_sell()
{
if (OrdersTotalByType(OP_SELL)>0)
{
   int pos=0;
   int res;
   for(pos = OrdersTotalByType(OP_SELL); pos >= 0; pos--)
     {
     if (OrderType() == OP_SELL)
        {
     res=OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
     if (res>0) Print(Symbol()," ");
     OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet); // 
     Sleep(zaderjka);
        }
     }
}     
return;
}

int close_buy()
{
if (OrdersTotalByType(OP_BUY)>0)
{
   int pos=0;
   int res;
   for(pos = OrdersTotalByType(OP_BUY); pos >= 0; pos--)
     {
     OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
     if (OrderType() == OP_BUY)
        {
     res=OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet); // 
     if (res>0) Print(Symbol()," ");
     Sleep(zaderjka);
        }
     }
}        
return;
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
if(Bars<100) {Print("=",Period(),TimeHour(CurTime()),":",TimeMinute(CurTime()),"  =",Bars,_GetLastError(err));}
if (close_all_swap==true) close_all_21();
if (trailing_parabol==true) trailing_all();
if (trailing_parabol==false) trailing_prost();
if (zakr_ubitok==true) zakr_ubitochn();   
expiration_otlojen();
   if (isNewBar())
      {
if (reshenie()==1 ) {SetOrderBuy();}
if (reshenie()<=-1) {SetOrderSell();}
return(0);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+

void expiration_otlojen()
{
   Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"      =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
   datetime friday;
   datetime c_time;
   c_time = CurTime();
   friday = c_time-TimeHour(c_time)*60*60-TimeMinute(c_time)*60-TimeSeconds(c_time);   //  friday -     00:00:00  
   friday = friday +86100; //    23:55
   int pos;   
   for(pos=0; pos<OrdersTotal(); pos++)
     {
       if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES) == true)
         {
           if (OrderType()>OP_SELL)
             {
                  Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  .. =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), 
                                      OrderTakeProfit(), friday);
             }
         }
       else
           err = GetLastError();  
err=GetLastError();           
_GetLastError(err);
     }
return(0);
}

//  
bool Close_vstrechn()
  { 
   int cnt1, err, tic1,tic2, LotBy, LotBy1,i,pos;
   bool ticdone;    
   int T1[10], T2[10], a;  
   a = 0;
   for(pos = 0; pos < OrdersTotal(); pos++)
     {
       //,        
       OrderSelect(pos, SELECT_BY_POS);         
       tic1 = OrderTicket();         
       LotBy = OrderLots();
       if(OrderType() == OP_SELL)
         {           
           for(i = 0; i < OrdersTotal(); i++)
             {
               OrderSelect(i, SELECT_BY_POS);             
               tic2 = OrderTicket();
               LotBy1 = OrderLots();
               //----
               if(OrderType() == OP_BUY && LotBy == LotBy1 && 
                  OrderSelect(tic1, SELECT_BY_TICKET) && OrderSelect(tic2, SELECT_BY_TICKET))
                  Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  . =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
                 {                
                   T1[a] = tic1;
                   T2[a] = tic2;                    
                   a++;
                 }
             }
         }
     } 
   for(pos = 0; pos < a; pos++)
     {
       //   
       if(OrderSelect(T1[pos], SELECT_BY_TICKET) && OrderSelect(T2[pos], SELECT_BY_TICKET))
         {
        Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  ...  =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
           ticdone = OrderCloseBy(T1[pos], T2[pos], Green);        
           if(!ticdone)
             {
               err = GetLastError(); 
               if(err != 0 && err != 1) 
                  Print ("    = ", Symbol(),"# "," - (buy-0, sell-1,buylim-2, sellim-3,buystop-4, sellstop-5)",OrderType(),"#",_GetLastError(err),"  -",AccountFreeMargin(),"  -",OrderProfit()," OpenPrice-",OrderOpenPrice(),"  -", Volume[1],"  -",Volume[0],_GetLastError(err));
             }
           Sleep(zaderjka);  
         }
     }  
   for(pos = OrdersTotal(); pos >= 0; pos--)
     {
       //    
       OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
       if(OrderSymbol() == Symbol())
         {
           if(OrderType() == OP_BUY)
             {
              Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"   .  =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
               ticdone = OrderClose(OrderTicket(), OrderLots(), Ask, 3, Green);
               if(!ticdone)
                 {
                   err = GetLastError(); 
                   if(err != 0) 
err=GetLastError();                       
_GetLastError(err);
                 }
               Sleep(zaderjka);  
             }
           if(OrderType() == OP_SELL)
             {
              Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"   . =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
               ticdone = OrderClose(OrderTicket(), OrderLots(), Bid, 3, Green);
               if(!ticdone)
                 {
                   err = GetLastError(); 
                   if(err != 0) 
err=GetLastError();                       
_GetLastError(err);
                 }
               Sleep(zaderjka);  
             }
         }
     }  
   return (False);       
  } 

//  
string _GetLastError(int err)
  {
   string error_string;
   switch(err)
     {
      //---- codes returned from trade server
      case 0:   error_string="                                                   "; break;
      case 1:   error_string="   ,                          "; break;
      case 2:   error_string="                                                 "; break;
      case 3:   error_string="                                       "; break;
      case 4:   error_string="                                         "; break;
      case 5:   error_string="                            "; break;
      case 6:   error_string="                                   "; break;
      case 7:   error_string="                                            "; break;
      case 8:   error_string="                                        "; break;
      case 9:   error_string="       "; break;
      case 64:  error_string="                                            "; break;
      case 65:  error_string="                                      "; break;
      case 128: error_string="                           "; break;
      case 129: error_string="                                            "; break;
      case 130: error_string="                                           "; break;
      case 131: error_string="                                           "; break;
      case 132: error_string="                                                 "; break;
      case 133: error_string="                                           "; break;
      case 134: error_string="                      "; break;
      case 135: error_string="                                              "; break;
      case 136: error_string="                                                      "; break;
      case 137: error_string="                                                 "; break;
      case 138: error_string="                                                   "; break;
      case 139: error_string="                         "; break;
      case 140: error_string="                                      "; break;
      case 141: error_string="                                        "; break;
      case 145: error_string="   ,        "; break;
      case 146: error_string="                                    "; break;
      case 147: error_string="           "; break;
      case 148: error_string="         "; break;
      case 4000: error_string= "                                                 "; break;
      case 4001: error_string= "                              "; break;
      case 4002: error_string= "    -                            "; break;
      case 4003: error_string= "                                  "; break;
      case 4004: error_string= "                  "; break;
      case 4005: error_string= "                     "; break;
      case 4006: error_string= "                           "; break;
      case 4007: error_string= "                               "; break;
      case 4008: error_string= "                                "; break;
      case 4009: error_string= "                        "; break;
      case 4010: error_string= "                             "; break;
      case 4011: error_string= "                                      "; break;
      case 4012: error_string= "                                    "; break;
      case 4013: error_string= "                                             "; break;
      case 4014: error_string= "                                        "; break;
      case 4015: error_string= "                                       "; break;
      case 4016: error_string= "                                "; break;
      case 4017: error_string= "   DLL                                   "; break;
      case 4018: error_string= "                             "; break;
      case 4019: error_string= "                                  "; break;
      case 4020: error_string= "               "; break;
      case 4021: error_string= "     ,    "; break;
      case 4022: error_string= "                                             "; break;
      case 4050: error_string= "                   "; break;
      case 4051: error_string= "                      "; break;
      case 4052: error_string= "                          "; break;
      case 4053: error_string= "                                             "; break;
      case 4054: error_string= "    -            "; break;
      case 4055: error_string= "                         "; break;
      case 4056: error_string= "                                       "; break;
      case 4057: error_string= "                      "; break;
      case 4058: error_string= "                          "; break;
      case 4059: error_string= "                         "; break;
      case 4060: error_string= "                                     "; break;
      case 4061: error_string= "                                       "; break;
      case 4062: error_string= "     string                          "; break;
      case 4063: error_string= "     integer                         "; break;
      case 4064: error_string= "     double                          "; break;
      case 4065: error_string= "                         "; break;
      case 4066: error_string= "         "; break;
      case 4067: error_string= "                       "; break;
      case 4099: error_string= "                                                "; break;
      case 4100: error_string= "                                    "; break;
      case 4101: error_string= "                                      "; break;
      case 4102: error_string= "                                "; break;
      case 4103: error_string= "                                     "; break;
      case 4104: error_string= "                           "; break;
      case 4105: error_string= "                                       "; break;
      case 4106: error_string= "                                         "; break;
      case 4107: error_string= "                "; break;
      case 4108: error_string= "                                       "; break;
      case 4109: error_string= "                                       "; break;
      case 4110: error_string= "                                 "; break;
      case 4111: error_string= "                                "; break;
      case 4200: error_string= "                                       "; break;
      case 4201: error_string= "                       "; break;
      case 4202: error_string= "                                        "; break;
      case 4203: error_string= "                                     "; break;
      case 4204: error_string= "                                           "; break;
      case 4205: error_string= "                                    "; break;
      case 4206: error_string= "                                 "; break;
      default:   error_string= "                                  "; break;       
      Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol()," =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
}                                 
   return(error_string);
}


double Lots()
   {
   double lot;
   Lot = NormalizeDouble( AccountEquity()*Procent_depo/100/Plecho, 1);//  .   
   if (Lot<0.1) Lot = 0.1;
    if(NormalizeDouble(AccountFreeMargin()/AccountLeverage()/10.0/Bid,2)<lot)
       {
        Alert("      ",lot,"  !...");
        return;
       }
   return(Lot);
   }
   
   
int zakr_ubitochn()
{
double ACCur, ACPrev;
int pos=0;
if (OrdersTotal()>0)
{
   for(pos = OrdersTotal(); pos >= 0; pos--)
     {
       OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
               if (OrderType() == OP_BUY && (Bid-OrderOpenPrice())/Point>0-my_prosadka)
                   {
                   Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"   . =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(GetLastError()));
                   OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet); // 
                   Sleep(zaderjka);
                   err=GetLastError();                   
                   _GetLastError(err);
                   return(0);  // 
                   }    
               else
               {
               if (OrderType() == OP_SELL &&  (OrderOpenPrice()-Ask)/Point>0-my_prosadka)
                   {
                   err=GetLastError();
                   Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"   . =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
                   OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet); // 
                   Sleep(zaderjka);  
                   err=GetLastError();
err=GetLastError();                   
_GetLastError(err);
                   return(0);  // 
                   }
              }
      }
}
return(0);
}

bool isNewBar()
  {
   bool res=false; 
   if(Time_0 != Time[0])  //   
   {
   Time_0 = Time[0];
   res=true;
   Print(Symbol()," ");
   } 
   return(res);
  }

//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void trailing_all()
  {
  int type;
  int EnterBar;//    
  double a; //    S=a*t^2/2
  double Zbar=ZeroBar,CurrParStop,TSdouble=TSpar;
  double minStopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
  a=TSdouble*2./Zbar/Zbar;
//----
   for (int i=0;i<OrdersTotal();i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==Symbol())
         {
         type=OrderType();
         if (type==OP_BUY) 
            {
            EnterBar=iBarShift(NULL,0,OrderOpenTime());
            if (EnterBar==0) continue;
            CurrParStop=NormalizeDouble(OrderOpenPrice()-(TSpar-a*EnterBar*EnterBar/2.0)*Point,Digits);
            if (CurrParStop>OrderStopLoss()) 
               {
               if (Bid-CurrParStop>minStopLevel*Point) {OrderModify(OrderTicket(),OrderOpenPrice(),
               CurrParStop,OrderTakeProfit(),0,Blue);
               Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol()," . =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));}
               else OrderModify(OrderTicket(),OrderOpenPrice(),Bid-minStopLevel*Point,OrderTakeProfit(),0,Blue);
               }
            }
         if (type==OP_SELL) 
            {
            EnterBar=iBarShift(NULL,0,OrderOpenTime());
            if (EnterBar==0) continue;
            CurrParStop=NormalizeDouble(OrderOpenPrice()+(TSpar-a*EnterBar*EnterBar/2.0)*Point,Digits);
            if (CurrParStop<OrderStopLoss()) 
               {
               if (CurrParStop-Ask>minStopLevel*Point){OrderModify(OrderTicket(),OrderOpenPrice(),
               CurrParStop,OrderTakeProfit(),0,Red);
               Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol()," . =", OrderType(),"  =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));}
               else OrderModify(OrderTicket(),OrderOpenPrice(),Ask+minStopLevel*Point,OrderTakeProfit(),0,Red);
               }
            }
         }
      }
//----
   return;
  }
  
bool trailing_prost()
{
  int type;
//----
   for (int i=0;i<OrdersTotal();i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==Symbol())
         {
         type=OrderType();
         if (type==OP_BUY) 
            {
            if (Bid-OrderStopLoss()>NormalizeDouble(my_trailing*Point,Digits+1)) OrderModify(OrderTicket(),
            OrderOpenPrice(),Bid-NormalizeDouble(my_trailing*Point,Digits+1),OrderTakeProfit(),0,Blue);
            }
         if (type==OP_SELL) 
            {
            if (OrderStopLoss()-Ask>NormalizeDouble(my_trailing*Point,Digits+1)) OrderModify(OrderTicket(),
            OrderOpenPrice(),Ask+NormalizeDouble(my_trailing*Point,Digits+1),OrderTakeProfit(),0,Blue);
            }
         }
      }
//----
return(0);
}



  //        
void close_all_21()
{
     if (TimeHour(CurTime())==MyHour_End && TimeMinute(CurTime())>=MyMinute_End && (TimeHour(CurTime())<=MyHour_Start) && TimeMinute(CurTime())<=MyMinute_Start && OrdersTotal()>0)
     {
     Print(" ...");
     Close_vstrechn();
     int pos;   
	  for (pos=OrdersTotal()-1;pos>=0;pos--)
	  {
	     int mode;
	     OrderSelect(pos, SELECT_BY_POS, MODE_TRADES);
	  	  mode=OrderType();
        if (OrderSymbol()==Symbol())  
         {
			if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),dop_prosadka_punkt,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),dop_prosadka_punkt,Red); }
         if (mode>OP_SELL) { OrderDelete(OrderTicket());}
         }
     }    
			return(0);
     }
     
return(0);
}

//+------------------------------------------------------------------+
//|  true,             |
//+------------------------------------------------------------------+
int AllowedOpenOrder(int _OrderType)
  {
//----
   int tip_ordera;
   int res=0;
   if (max_open_orders<=0) Alert(Symbol(),"-  - 0 !!!");
   else {
   res=max_open_orders-OrdersTotalByType(_OrderType);
   Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"   ",_OrderType,"=",res,"|||"," =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
   }
   return(res);
  }
  
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
int OrdersTotalByType(int _OrderType)
  {
   int res;
   for (int i=0;i<OrdersTotal();i++)
      {
      //if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) &&  OrderSymbol()==Symbol())
      if (OrderSymbol()==Symbol())
         {
         if (OrderType()!=_OrderType) continue; //    
         res++;
         }
      }
   return(res);
  }
 

int reshenie()
{
int res_all=0;
int count_signal=0;
if (my_iMA) count_signal++;
if (my_iMA2) count_signal++;
if (my_iMA3) count_signal++;
if (my_MACD) count_signal++;
if (my_PIVOT) count_signal++;
if (my_SupRes) count_signal++;
if (my_iMA4) count_signal++;
if (my_iMACD2) count_signal++;
if (my_iRSI) count_signal++;
if (count_signal==0) Alert("     !!!");
res_all=sign_iMA()+sign_iMA2()+sign_iMA3()+sign_MACD()+sign_PIVOT()+sign_SupRes()+sign_iMA4()+sign_iMACD2()+sign_iRSI();
if (res_all>=count_signal/2) res_all=1;
if (res_all<=(-1)*count_signal/2) res_all=-1;
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol()," = ",res_all," =",count_signal," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
return(res_all);
}

  int sign_iMA()
  {
 int res1=0;
 if (my_iMA)
 {
   double ma1;
   double ma2;
   double ma3;
   double ma4;
   double ma5;
   double ma6;
   ma1=iMA(NULL,0,24,6,0,PRICE_CLOSE,1);
   ma4=iMA(NULL,0,24,6,0,PRICE_CLOSE,0);
   ma2=iMA(NULL,0,60,6,0,PRICE_CLOSE,1);
   ma5=iMA(NULL,0,60,6,0,PRICE_CLOSE,0);
   ma3=iMA(NULL,0,120,6,0,PRICE_CLOSE,1);
   ma6=iMA(NULL,0,120,6,0,PRICE_CLOSE,0);
     if (ma1<ma2 && ma2<ma3 && ma5<ma4 && ma4<ma6)
     {
      res1=1;
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res1= ",res1," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
      return(res1);
     }
     if (ma1>ma2 && ma2>ma3 && ma5>ma4 && ma4>ma6)  
     {
      res1=-1;
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res1= ",res1," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
      return(res1);
     }
 }
return(res1);
}

int sign_iMA2()
  {
int res2=0;
if (my_iMA2)
{
int     MA1 = 11;                   //  1-  my_iMA2
int     MA2 = 23;                   //  2-  my_iMA2
switch (Period())           
   {                        
   case PERIOD_M1: 
{
MA1 = 11;
MA2 = 23;
break; 
}
   case PERIOD_M5:   
{
MA1 = 11;
MA2 = 23;
break; 
}
   case PERIOD_M15:  
{
MA1 = 11;
MA2 = 23;
break; 
}
   case PERIOD_M30:  
{
MA1 = 11;
MA2 = 23;
break; 
}
   case PERIOD_H1:   
{
MA1 = 11;
MA2 = 23;
break;  
}
   case PERIOD_H4:   
{
MA1 = 11;
MA2 = 23;
break;  
}
   case PERIOD_D1:   
{
MA1 = 11;
MA2 = 23;
break;  
}
   }                        
double 
   Lot,                                                  //  
   Pred,                                                 //   1-  ()
   Tek,                                                  //      1-  ()
   Golub;                                                //      2- ()
Tek=iMA(NULL,0,MA1,0,MODE_LWMA,PRICE_TYPICAL,0);//1-
Pred=iMA(NULL,0,MA1,0,MODE_LWMA,PRICE_TYPICAL,1);//2-
Golub=iMA(NULL,0,MA2,0,MODE_LWMA,PRICE_TYPICAL,0);//2-
   int ret=0;                                                //    !!:)
   if ((Pred<=Golub && Tek> Golub) || (Pred< Golub && Tek>=Golub)  ) res2=1;             //          
   if ((Pred>=Golub && Tek< Golub) || (Pred> Golub && Tek<=Golub)  ) res2=-1;             //   
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res2= ",res2," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
return(res2);
}

int sign_iMA3()
{
if (my_iMA3)
{
double MA;
int res3=0;
int MAPeriod=13;                    // my_iMA3
MA=iMA(NULL,0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,0);
if(MA>Close[1]) {res3=1;}
if(MA<Close[1]) {res3=-1;}
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res3= ",res3," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
return(res3);
}


int sign_MACD()
{
int res4=0;
if (my_MACD)
{
int Sold=0,Bought=0;
int signalPeriod = 9;               // parameters for MACD and OSMA
int timeFrame = 0;                  // parameters for MACD and OSMA
int   emaFast = 12;                 // parameters for MACD and OSMA
int   emaSlow = 26;                 // parameters for MACD and OSMA

double Trigger0=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,0);
double Trigger1=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,1);
double Trigger2=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_MAIN,2);
double Signal0=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_SIGNAL,0);
double Signal1=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_SIGNAL,1);
double Signal2=iMACD(NULL,timeFrame,emaFast,emaSlow,signalPeriod,PRICE_CLOSE,MODE_SIGNAL,2);
if(Bought==0&&(Trigger0<0&&Trigger0<Signal0)){res4=1;}
if(Sold==0&&(Trigger0>0&&Trigger1<Signal1)){res4=-1;}
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res4= ",res4," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
return(res4);
}


int sign_PIVOT()
{
int res5=0;
if (my_PIVOT)
{
double iTmp=0;
int   TimeZone=16;                  // Time zone to calculate the pivots (not all the methods uses it)
iTmp=iCustom(Symbol(),0,"PivotLinesTimeZone",TimeZone,true,false,false,0,0);
	if(Close[0]<iTmp){res5=-1;}
	if(Close[0]>iTmp){res5=1;}
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res5= ",res5," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
	return(res5);
}


int sign_SupRes()
{
int res6=0;
if (my_SupRes)
{
double iTmpR=0, iTmpS=0;
iTmpR=iCustom(Symbol(),0,"Support Resistance",0,0);
iTmpS=iCustom(Symbol(),0,"Support Resistance",1,0);
	if(Close[0]==iTmpR){res6=1;}
	if(Close[0]==iTmpS){res6=-1;}
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res6= ",res6," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
	return(res6);
}


int sign_iMA4()
{
int res7=0;
if (my_iMA4)
{
double ma;
double MovingPeriod       = 12;     // iMA4
double MovingShift        = 6;      // iMA4
ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
if (Open[1]<ma && Close[1]>ma) {res7=1;}
if (Open[1]>ma && Close[1]<ma) {res7=-1;}
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res7= ",res7," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
return(res7);
}


int sign_iMACD2()
{
int res8=0;
if (my_iMACD2)
{
if (iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,0)>iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,1)) { res8=1; }
if (iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,0)<iMACD(NULL,0,14,26,9,PRICE_CLOSE,MODE_MAIN,1)) { res8=-1; }
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res8= ",res8," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
return(res8);
}

int sign_iRSI()
{
if (my_iRSI)
{
int res9;
double MA_iRSI;
double pcu1;
double pcu2;
int total;
  MA_iRSI=iWPR(NULL,0,60,0);
   pcu1=iRSI(NULL,0,3,PRICE_LOW,0);
   pcu2=iRSI(NULL,0,3,PRICE_HIGH,0);
   total=OrdersTotal();
   static int lt;
if(MA_iRSI<-97.9&&pcu2<18) res9=1;
if(MA_iRSI>-4.1&&pcu1>85) res9=-1;
Print(TimeHour(CurTime()),":",TimeMinute(CurTime()),"|",Symbol(),"  res9= ",res9," !!!   =",AccountFreeMargin()," =", Bars," W1=", Volume[1], " W0=",Volume[0]," =",OrderProfit(),_GetLastError(err));
}
return(res9);
}